Description

Dear David,

Could you please tag dunetpc v08_26_00?

In the current version we updated the ARAPUCA geometry with more details. Unfortunately this breaks the Cl test:
http://dbweb5.fnal.gov:8080/LarCl/app/ns:dune/storage/docs/2019/07/21/test GeometryProtoDune_.log

968: # Optical detectors: 90

969: 90 != 60

970: test_GeometryProtoDune: /scratch/workspace/dune_ci/label_exp/SLF7/label_exp2/swarm/DUNE/srcs/
dunetpc/dune/Geometry/test/test_GeometryDune.cxx:114: void {anonymous}::check (std::___cxxll::string
, T, V, bool) [with T = unsigned int; V = unsigned int; std::__cxxll::string = std::__cxxll::basic

_string<char>]: Assertion " false' failed.
Alex knows more details
Could you please help fix this Cl test before tagging the new release?

Thanks,
Tingjun

History

#1 - 07/22/2019 07:37 AM - David Adams

- Status changed from New to Work in progress

I am working on this now.

#2 - 07/22/2019 07:40 AM - Tingjun Yang

Shall we fix the ci test first but wait after the pandora update before tagging?
Alex, could you copy the pandora xml to dune_pardata?

Thanks!

#3 - 07/22/2019 08:29 AM - David Adams

| suppose there are intended changes in the optical detector geometry. Here is what the test expects:

// Optical detectors.

// ... # detectors

ev.nopdet = l0*ev.napa;

// ... # channels in each detector

ev.nopdetcha.resize (ev.nopdet, 4);

ev.nopdetcha[30] = 12;

ev.nopdetcha[47] = 12;

// ... First channel in each detector

vector<Index> firstChan = {
144, 0, 148, 4, 152, 8, 156, 12, 160, 1e,
l64, 20, 168, 24, 172, 28, 176, 32, 180, 36,
240, 48, 244, 52, 248, 56, 252, 60, 256, 64,
264, 68, 260, 72, 276, 76, 280, 80, 284, 84,
http://dbweb5.fnal.gov:8080/LarCI/app/ns:dune/storage/docs/2019/07/21/test_GeometryProtoDune_.log

216, 96, 220, 100, 224, 104, 228, 132, 192, 108,
232, 112, 196, 116, 200, 120, 236, 124, 204, 128
bi
ev.opdetcha.resize (ev.nopdet) ;
Index ncha = 0;

for a total of 6*10 = 60 optical detectors. Apparently the new geometry has 90:

# Optical detectors: 90

90 !'= 60

test_GeometryProtoDune: /nashome/d/dladams/dev/dudev0l/workdir/srcs/dunetpc/dune/Geometry/test/test_GeometryDu
ne.cxx:114: void {anonymous}::check(std::___cxxll::string, T, V, bool) [with T = unsigned int; V = unsigned int
; std::__cxxll::string = std::__cxxll::basic_string<char>]: Assertion "false' failed.

Aborted

Is this 15/APA? Any other obvious changes in the above code?

da

#4 - 07/22/2019 08:32 AM - David Adams

One obvious change: the firstChan array will have to be extended to 90 values. --da

#5 - 07/22/2019 09:53 AM - David Adams

When | iterate over the 90 detectors and call pgeo->NOpHardwareChannels(idet), | find a total of 376 channels but when | call
pgeo->NOpChannels(), there are 256 channels. The testing expects these to be the same. Is there a problem with the geometry? If not can you help
me understand why these numbers should be different? Thanks. --da

#6 - 07/22/2019 10:52 AM - Alexander Himmel

So, 90 detectors is correct. We removed 2 and added 2x16, so 60-2+2*16 = 90 is correct.

| will look into NOpHardwareChannels. There is actually good reason that the sum of NOpHardwareChannels won't match up, since this new
geometry now has channels which correspond to multiple OpDets (which didn't occur previously), so those channels will be double counted by the
sum of NOpHardwareChannels. However, there are only 16 OpDets which share channels, so the two should only differ by 8, not 120.

#7 - 07/22/2019 11:43 AM - David Adams

Thanks. | will modify the test to allow readout channels to share detector channels.

| also see a crash in this call:

#4 0x000000000040c95f in test_GeometryDune (ev=..., dorop=dorop@entry=true, maxchanprint=<optimized out>,
useExistingFcl=useExistingFcl@entry=false) at /nashome/d/dladams/dev/dudev0l/workdir/srcs/dunetpc/dune/Geo

metry/test/test_GeometryDune.cxx:520

520 Index icha = pgeo->OpChannel (iopt, ioch);

(gdb) p iopt

$2 = 60

(gdb) p ioch

$3 =0

All is fine for the first 60 channels.
da

#8 - 07/22/2019 12:27 PM - Alexander Himmel

There was also a change in the geometry name which caused the wrong channel map to be loaded, which | suspect is causing some of the other
issues. I'm rebuilding now (since we have a new larsoft dependency) and will see what remains after that is fixed.

#9 - 07/22/2019 12:57 PM - Tingjun Yang

My fault and my apologies.
#10 - 07/22/2019 01:18 PM - Alexander Himmel
OK, I've fixed the name, but this failure:

1. Optical channels: 264
264 =376

Appears intimately related to the re-implementation of the PD channel map in the test. All of these numbers need to change in some non-trivial ways:
// ... # channels in each detector
ev.nopdetcha.resize (ev.nopdet, 4);

ev.nopdetcha[30] = 12;
ev.nopdetcha[47] = 12;
// ... First channel in each detector

vectoré&lt; Index&gt; firstChan = {
144, 0, 148, 4, 152, 8, 156, 12, 160, 16,
164, 20, 168, 24, 172, 28, 176, 32, 180, 36,
240, 48, 244, 52, 248, 56, 252, 60, 256, 64,
264, 68, 260, 72, 276, 76, 280, 80, 284, 84,
216, 96, 220, 100, 224, 104, 228, 132, 192, 108,
232, 112, 196, 116, 200, 120, 236, 124, 204, 128

bi

So, as | said above, unless there's an automated way to regenerate them, | say we just remove this test and proceed.

#11 - 07/22/2019 01:28 PM - Alexander Himmel

I've committed the fixes to the name, but left the rest of the test as-is.

#12 - 07/22/2019 02:52 PM - David Adams

| am working on the test now...

#13 - 07/22/2019 05:08 PM - Tingjun Yang

| merged Josh's feature branch which caused many problems. We should wait until the problems are fixed before tagging the release.

#14 - 07/22/2019 07:44 PM - David Adams

- Status changed from Work in progress to Feedback

OK, I will wait to hear from you.

#15 - 07/22/2019 07:59 PM - Tingjun Yang

You can still fix the ci test in the meanwhile.

#16 - 07/23/2019 07:48 AM - Tingjun Yang
David, thanks for fixing the PD channel map in Cl test.
Is test_AdcNoiseSignalFinder a new Cl test? This test occasionally fails:

http://doweb5.fnal.gov:8080/LarCl/app/ns:dune/storage/docs/2019/07/23/backtrace.test_ AdcNoiseSignalFinder.48268.buildservice009.fn_ BwGOgZ6.t
est_AdcNoiseSi

| wonder if it is a memory issue.

#17 - 07/23/2019 08:09 AM - Leigh Whitehead

| have pushed some changes to reinstate the files that were accidentally edited / removed in the merge commit. I've also added Josh's code, so
waiting to see if the Cl tests are ok now.

#18 - 07/23/2019 08:44 AM - David Adams

| pushed a fix to the geometry test last night. | am working on the AdcNoiseSignalFinder test now.

#19 - 07/23/2019 09:07 AM - David Adams

| pushed a fix for the AdcNoiseSignalFinder test. It makes use of rand which has a fixed sequence in C but apparently not in C++. | added a call to
srand and now get the same results each time | run the test.

#20 - 07/23/2019 02:09 PM - Tingjun Yang
Hi David,
| think we are good to go. Could you please tag release v08_26_007?

Thanks,
Tingjun

#21 - 07/23/2019 04:10 PM - David Adams

Test build is underway...
http://dbweb5.fnal.gov:8080/LarCI/app/ns:dune/storage/docs/2019/07/23/backtrace.test_AdcNoiseSignalFinder.48268.buildservice009.fn_BwGOgZ6.test_AdcNoiseSi
http://dbweb5.fnal.gov:8080/LarCI/app/ns:dune/storage/docs/2019/07/23/backtrace.test_AdcNoiseSignalFinder.48268.buildservice009.fn_BwGOgZ6.test_AdcNoiseSi

#22 - 07/23/2019 06:07 PM - David Adams

- Status changed from Feedback to Work in progress

Tag is made and builds underway...

#23 - 07/23/2019 09:03 PM - David Adams
The ¢2 builds are failing:

[ 93%] Linking CXX shared library ../../lib/1ibTOCounter_module.so
Scanning dependencies of target ProtoDUNETruthBeamParticle_module
/scratch/workspace/dune-release-build/BUILDTYPE/prof/QUAL/c2/labell/swarm/label2/SLF6/temp/srcs/dunetpc/dune/T
OReco/TORecoSCE_module.cc:181:10: error: private field 'corrected_flash_reco_time_diff' is not used [-Werror,—
Wunused-private-field]

double corrected_flash_reco_time_diff;

~

1 error generated.

make[2]: *** [dunetpc/dune/TOReco/CMakeFiles/TORecoSCE_module.dir/TORecoSCE_module.cc.o] Error 1
make[1l]: *** [dunetpc/dune/TOReco/CMakeFiles/TORecoSCE_module.dir/all] Error 2

make[1l]: *** Waiting for unfinished jobs....

#24 - 07/23/2019 09:16 PM - David Adams
The gcc builds are installed.
The linux c2 builds have all failed and the mac builds are still running.

#25 - 07/24/2019 02:48 AM - Leigh Whitehead

| have pushed a fix for the C2 build if we want to worry about it.

#26 - 07/24/2019 09:08 AM - David Adams

Leigh:

Thanks.

Did you do a full build on ¢2 to check there are no other similar problems?
da

#27 - 07/24/2019 09:11 AM - David Adams

- Status changed from Work in progress to Closed

As expected, the other c2 builds failed.

We will need a new tag and version to include Leigh's fix. | suppose this can wait until the next release.
In any case, this task is done and we have a gcc-only release.

da
